namespace BP
{
	class WorldChar : ScriptObject
	{
		kActor @self;
		
		float offset;
		kVec3 origin;
		kVec3 originOffset;
		kActor@ srcActor;
		kActor@ target;
		//------------------------------------------------------------------------------------------------------------------------
		WorldChar(kActor@ actor)
		{
			@self = @actor;
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnSerialize(kDict& out dict)
		{
			SERIALIZE_FLOAT(offset);
			SERIALIZE_VECTOR(origin);
			SERIALIZE_VECTOR(originOffset);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnDeserialize(kDict& in dict)
		{
			DESERIALIZE_FLOAT(offset);
			DESERIALIZE_VECTOR(origin);
			DESERIALIZE_VECTOR(originOffset);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void UserEvent(const float x, const float y, const float z, const float f1, const float f2, const float f3, const float f4)
		{
			int msg = int(f1);
			switch (msg)
			{
				case USEREVENT_MSG_SPAWN:
				{
					int charValue = BP_Particle_CharStart + BP::UserEvent::argInts[0];
					origin = BP::UserEvent::argVectors[0];
					originOffset = BP::UserEvent::argVectors[1];
					offset = BP::UserEvent::argFloats[0];
					@srcActor = @BP::UserEvent::argActors[0];
					@target = @BP::UserEvent::argActors[1];
					origin += originOffset;
					kParticle @particle = BP::Spawn::Particle(charValue, @self);
					if (particle is null)
					{
						//this message gets spammed in mp alot of the time
						//DebugError("[BP::WorldChar::UserEvent] Spawning particle " + charValue + " returned null");
						self.Remove();
					}
					else
					{
						particle.Origin() = origin;
					}
					self.SetTarget(@particle);
					break;
				}
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnTick()
		{
			if (self.GetTarget() is null)
			{
				self.Remove();
				return;
			}

			kParticle @particle = self.GetTarget().CastToParticle();
			
			if (particle.IsStale())
			{
				self.Remove();
				return;
			}
			
			if (target !is null)
			{
				origin = target.Origin() + originOffset;
			}
			
			if (srcActor !is null)
			{
				kVec3 localDir = kVec3(1, 0, 0) * (kVec3(origin.x, origin.y, srcActor.Origin().z) - srcActor.Origin()).ToQuat();
				particle.Origin() = origin + localDir * offset;
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
	};
}
