namespace BP
{
	namespace Maps
	{
		class ScriptMap : ScriptActor
		{
			int playerCount;
			//------------------------------------------------------------------------------------------------------------------------
			ScriptMap(kActor@ actor)
			{
				super(actor);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnSerialize(kDict dict) override
			{
				SERIALIZEKEY_INT("difficulty", BP::Game::difficulty);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnDeserialize(kDict& in dict) override
			{
				DESERIALIZEKEY_INT("difficulty", BP::Game::difficulty);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnTick() override
			{
				//health is map time because that way we don't have to make a UserEvent call to get the time
				self.Health() += GAME_DELTA_TIME;
				
				if (IsNetServer)
				{
					//check if game mode changes
					int svGameMode = BP::Cvar::Get("sv_gamemode").Atoi();
					if (BP::mpGameMode != svGameMode)
					{
						BP::mpGameMode = svGameMode;
						SendMPGameMode(BP::mpGameMode);
					}
					
					//Check if player count changes
					int nPlayers = 0;
					{
						FOREACH_ACTOR
						{
							if (actor.Type() == kActor_Player && !BP::Actor::IsMPPlayerNotInGame(@actor))
							{
								nPlayers++;
							}
						}
					}
					
					if (nPlayers != playerCount)
					{
						if (nPlayers > playerCount)
						{
							SetAllNetModsSilent();
							BP::UserEvent::MPPlayerJoin(@BP::Map::Actor(), nPlayers);
							array<int> tids;
							FOREACH_ACTOR
							{
								int tid = actor.TID();
								if (tid >= 0 && tids.find(tid) < 0)
								{
									BP::UserEvent::ActorNetSend(@actor);
									tids.insertLast(tid);
								}
							}
						}
						playerCount = nPlayers;
					}
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
		};
	}
}
