namespace BP
{
	namespace UserEvent
	{
		int instanceIDResult;
		BP::ScriptActor@ scriptResult;
		
		array<kActor@> argActors;
		array<int> argInts;
		array<int16> argShorts;
		array<float> argFloats;
		array<bool> argBools;
		array<kVec3> argVectors;
		array<kStr> argStrings;
		//------------------------------------------------------------------------------------------------------------------------
		void WorldCharSetup(kActor@ srcActor, kActor@ charActor, kActor@ target, const int charValue, const kVec3& in origin, const kVec3& in originOffset, const float offset)
		{
			argInts = array<int> = { charValue };
			argFloats = array<float> = { offset };
			argVectors = array<kVec3> = { origin, originOffset };
			argActors = array<kActor@> = { @srcActor, @target };
			Call(@charActor, USEREVENT_MSG_SPAWN);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void PlayerStarted(kActor@ actor, kActor@ playerActor)
		{
			argActors = array<kActor@> = { @playerActor };
			Call(@actor, USEREVENT_MSG_PLAYER_STARTED);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void PlayerRevived(kActor@ actor, kActor@ playerActor)
		{
			argActors = array<kActor@> = { @playerActor };
			Call(@actor, USEREVENT_MSG_PLAYER_REVIVED);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void AIStarted(kActor@ actor, kActor@ aiActor)
		{
			argActors = array<kActor@> = { @aiActor };
			Call(@actor, USEREVENT_MSG_AI_STARTED);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void AIKilled(kActor@ actor, kActor@ aiActor, kActor@ killer)
		{
			argActors = array<kActor@> = { @aiActor, @killer };
			Call(@actor, USEREVENT_MSG_AI_KILLED);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void MPPlayerJoin(kActor@ actor, int playerCount)
		{
			argInts = array<int> = { playerCount };
			Call(@actor, USEREVENT_MSG_MP_PLAYER_JOIN);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void ActorNetReceive(kActor@ actor, array<int>& int32Args, array<int16>& int16Args)
		{
			argInts = int32Args;
			argShorts = int16Args;
			Call(@actor, USEREVENT_MSG_ACTOR_NETRECEIVE);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void ActorNetSend(kActor@ actor)
		{
			Call(@actor, USEREVENT_MSG_ACTOR_NETSEND);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void GetScript(kActor@ actor)
		{
			@scriptResult = null;
			Call(@actor, USEREVENT_MSG_GET_SCRIPT);
		}
		//------------------------------------------------------------------------------------------------------------------------
		BP::AI@ GetAIScript(kActor@ actor)
		{
			GetScript(@actor);
			return cast<BP::AI>(scriptResult);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void Call(kActor @actor, int msg)
		{
			if (actor !is null)
			{
				Event.RunAction(actor, null, ACTION_USER, Math::vecZero, msg, 0, 0, 0);
				argActors.resize(0);
				argInts.resize(0);
				argShorts.resize(0);
				argFloats.resize(0);
				argBools.resize(0);
				argVectors.resize(0);
				argStrings.resize(0);
			}
			else
			{
				DebugError("[BP::UserEvent::Call] actor is null with msg " + msg);
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
	}
}
